Subject: "newbie" questions: GPG a.k.a. GnuPG versus PGP corporation's products ... ; et cetera

From: "gerry_lowry \(alliston ontario canada\)" <[email-masked]>
Date: Sun, 1 Feb 2009 14:14:50 -0500

Hello,

I'm calling myself a "newbie" with regards to PGP/GPG even though I've through my own
ignorance and incompetence orphaned keys back as far as September 1997.  One day
my brain may, if I am lucky, reconnect with their corresponding passphrases so that
I can revoke them.  I'm guessing there is a very large number of orphaned keys in the PGP universe.

I've read about PGP in Chey Cobb's "Cryptography for Dummies" and PGP/GPG in Michael W. Lucas'
"PGP & GPG:  email for the practical paranoid".  Also, I've used gnupg.pdf as a reference but have
yet to digest all of its 148 pages.

I live under the cloud of the virus a.k.a. Windows [XP, Vista, Server 2003, Server 2008].

     gpg (GnuPG) 1.4.9
     Supported algorithms:
     Pubkey: RSA, RSA-E, RSA-S, ELG-E, DSA
     Cipher: 3DES (S2), CAST5 (S3), BLOWFISH (S4), AES (S7), AES192 (S8), AES256 (S9), TWOFISH (S10)
     Hash: MD5 (H1), SHA1 (H2), RIPEMD160 (H3), SHA256 (H8), SHA384 (H9), SHA512 (H10), SHA224 (H11)
     Compression: Uncompressed (Z0), ZIP (Z1), ZLIB (Z2), BZIP2 (Z3)

Although there are GUI environments available, for the present, I am sticking with GnuPG and its
various command line tools until I understand them sufficiently to warrant investigating GUI tools.
The former MIT GUI distribution never integrated very well with Outlook Express, at least,
that was my experience.  This is a second reason why I prefer command line tools.

QUESTION # 1:  There seems to currently exist TWO forces in the PGP universe:

                                 (a) GPG -- GnuPG (OpenPGP initiative)
                                 (b) PGP -- PGP Corporation.

                             To what extent are their goals aligned?  More specifically, since (b) is a corporation
                             which is driven by the profit motive and (a) would like to make a reasonable living
                             but is likely more open than the average corporate culture, it's likely more in the
                             interested of (b) to succeed in being universal but not too universal, i.e., to some
                             degree, (b) could grab more market share by being somewhat proprietary.
                             OTOH, it's possible AFAIK that (a) could not succeed without being 100%
                             compatible with (b).

QUESTION # 2:  I have looked at http://www.biglumber.com/ ... http://biglumber.com/x/web?va=1:
                             "Total of 3190 listings (3107 people [442 with images], 83 events) in 79 countries and 1144 cities."
                             613 listings are expired; even if the 613 listings are NOT part
                             of the 3190 listings, "biglumber" is not very much in use.
                             http://pgp.mit.edu/ has been around for many years.  It's possibly a better
                             indicator of how many keys their are ... sadly, it does not appear to offer
                             much in the way of statistics.  OTOH, I almost never receive even PGP
                             signed e-mails.  I spoke with a senior I.T. person recently who was
                             not even aware of PGP technology.

                             To what extent is GPG/PGP technology being used by e-mail users?
                             I'm guessing it must be less than 1% based on the many 1000's of
                             e-mails that I have received each month over the last decade.

I'll have more questions and I hope comments that you'll find useful later.

Thank you for your opinions.

Regards,
Gerry (Lowry)

---

From: Christoph Anton Mitterer <[email-masked]>
Date: Sun, 01 Feb 2009 20:53:10 +0100

On Sun, 2009-02-01 at 14:14 -0500, gerry_lowry (alliston ontario canada)
> I live under the cloud of the virus a.k.a. Windows [XP, Vista, Server 2003, Server 2008].
Ok let me just skip a possibly flame war triggering comment on how
windows and cryptologic security can go hand in hand ;-)

I do not like your indenting :P

>                                  (b) PGP -- PGP Corporation.
These are probably THE main players, but we have quite some other
implementations.

>                              degree, (b) could grab more market share by being somewhat proprietary.
Well at least they've managed to work together on the standard so I'd
say that there's a good relationship.
But David, Hal, Jon and Werner could answer this probably better =)

>                              OTOH, it's possible AFAIK that (a) could not succeed without being 100%
I don't think so,.. as especially in the Linux/OpenSource community
nearly everybody use gnupg. Please don't interpret this as if I wouldn't
like PGP or its staff). Is there a Linux version of pgp, at all?

>                              http://pgp.mit.edu/ has been around for many years.
This is only one of many keyersers.

> OTOH, I almost never receive even PGP
Well,... I won't comment on this...

>                              e-mails that I have received each month over the last decade.
It's quite widespread in the OpenSource community, and you should not
forget that OpenPGP is far more than just email.
Look e.g. at the Debian project which signs all its packages via
OpenPGP.

Of course the usage depends on the community which you're part of.

In the last time X.509 advanced more and more, and especially stuff like
Thawte's wot or CACert.
But these provide by far less security IMHO.
In general they depend on a single root with their limited strict
hierarchical PKI.
Which means effectively, everything depends on the root cert.
If this is somehow compromised,... game's over.
It's even worse, as most people have never received the root cert in a
secure way (just downloaded it from the web, or shipped with the
browser, et cetera)

And to come back to these two, CACert and thawte, already two people
(two assurers with the necessary points) can forge an identity.

So apart from military solutions, proprietary standards or rarely-used
PKIs you can right now only choose between:
-OpenPGP
-something X.509 based (e.g. CMS, S/MIME)

And IMHO it's clear, which one of the two provides (or can provide)
security and which one not (that much).
(I think this has the potential to start a flame war ^^)

Just my 0.02€,
-- 
Christoph Anton Mitterer
Ludwig-Maximilians-Universität München

[email-masked]
[email-masked]

---

From: John Clizbe <[email-masked]>
Date: Sun, 01 Feb 2009 23:01:22 -0600

gerry_lowry (alliston ontario canada) wrote:
> Hello,
> 
> I'm calling myself a "newbie" with regards to PGP/GPG even though I've 
> through my own ignorance and incompetence orphaned keys back as far as
> September 1997. One day my brain may, if I am lucky, reconnect with their
> corresponding passphrases so that I can revoke them. I'm guessing there is a
> very large number of orphaned keys in the PGP universe.
> 
> I've read about PGP in Chey Cobb's "Cryptography for Dummies" and PGP/GPG in
> Michael W. Lucas' "PGP & GPG: email for the practical paranoid". Also, I've
> used gnupg.pdf as a reference but have yet to digest all of its 148 pages.

I remember Cobb's book as being more weighted to X.509 and PKCS. Not read Lucas,
so I can't comment on it other than I recall it having a cover blurb by Len
Sassaman, who also posts here. I guess gnupg.pdf is fine if the v2.0
specifics are filtered out.

> I live under the cloud of the virus a.k.a. Windows [XP, Vista, Server 2003,

At one time, 70-75% of Enigmail downloads were Windows users.

I'm not one for Windows-bashing - I consider it "So-o-o-o-o-o Last Century" ;-)

> Although there are GUI environments available, for the present, I am sticking
> with GnuPG and its various command line tools until I understand them 
> sufficiently to warrant investigating GUI tools. The former MIT GUI
> distribution never integrated very well with Outlook Express, at least,

You're missing out on some good work and the chance to help push that work
by submitting user feedback.

The GPGshell front-end to GnuPG seems to be preferred by folks moving over from
or familiar with PGP Desktop.

Are you only interested in integration with OE? The PGP plugin, as I recall,
worked well with both Outlook and OE (PGP 8.1). GnuPG integration with Outlook
2003 is possible with the GPGol plugin bundled in GPG4Win. If switching mail
clients is an option, Thunderbird+Enigmail & GnuPG may work well for you (but
I'm biased).

> To what extent are their goals aligned? More specifically, since (b) is a
> corporation which is driven by the profit motive and (a) would like to make a
> reasonable living but is likely more open than the average corporate culture,
> it's likely more in the interested of (b) to succeed in being universal but not
> too universal, i.e., to some degree, (b) could grab more market share by being
> somewhat proprietary. OTOH, it's possible AFAIK that (a) could not succeed
> without being 100% compatible with (b).

Two _major_ forces. I think there are something around fifteen different
implementations of the OpenPGP RFC. GnuPG and PGP just seem to have the largest
share of user awareness.

GnuPG succeeds quite well without being 100% compatible with PGP, and vice
versa. They each have differences.

An implementation is only required to implement the MUST portions of the
standard. What optional features or extensions they package is their choice.

> QUESTION # 2:  I have looked at http://www.biglumber.com/ ... 
> http://biglumber.com/x/web?va=1: "Total of 3190 listings (3107 people [442
> with images], 83 events) in 79 countries and 1144 cities."
> 613 listings are expired; even if the 613 listings are NOT part of the 3190 
> listings, "biglumber" is not very much in use. http://pgp.mit.edu/ has been 
> around for many years.  It's possibly a better indicator of how many keys 
> their are ... sadly, it does not appear to offer much in the way of 
> statistics.

2662848 on the SKS keyservers as of 14:45 today (1-Feb-2009 US/Central)

Sadly, the server code on pgp.mit.edu is way out of date. I don't believe it is
even being maintained. The PKS code is known to behave badly with certain
features of newer V4 keys. I've never heard that this was reliably fixed - some
servers were patched to not do damage, but I don't believe the patches were
well-distributed.

> OTOH, I almost never receive even PGP signed e-mails.  I spoke 
> with a senior I.T. person recently who was not even aware of PGP technology.

I'm never surprised by what Sr IT folks don't know. Never. Ever.

> e-mails that I have received each month over the last decade.

A friend just posted this anecdote a couple days ago to the [GnuPG-Users] list:
+> At last year's USENIX, in a panel discussion, Dan Wallach of Rice
+> declared Enigmail the best thing going in terms of OpenPGP integration.
+> That's high praise coming from a very well-respected guy in computer
+> security.
+>
+> This was said as part of a sidebar he made about the difficulty in
+> getting 30+ Ph.Ds in computer science to all use PGP for a particular
+> mailing list.  Some were using Evolution, some were using ancient PGP,
+> some were using modern PGP, some were using plugins, others were C&Ping
+> into a Microsoft Word document then using some weird Word PGP plugin,
+> some were using Enigmail, etc.  He capped it off with an exasperated
+> sigh, then recommended Enigmail to people who needed OpenPGP
+> integration, as Enigmail gave the least troubles.

If CS professors with interest in computer security can't get OpenPGP working
within their own group, what do _you_ think are the chances for the "Average User"?

> I'll have more questions and I hope comments that you'll find useful later.

Could you please format them in a more friendly manner. Most folks seem to limit
line lengths to < 80 characters. It was a bit of a chore to rewrap your message.

You may also find the GnuPG-Users list (gnupg-users[AT]gnupg.org) and the Yahoo!
PGP-Basics group (PGP-Basics[AT]yahoogroups.com) helpful. In fact, both of those
are probably great places to continue this discussion.

> Thank you for your opinions.

Thank you for your questions.

- --
John P. Clizbe                      Inet:John (a) Mozilla-Enigmail.org
You can't spell fiasco without SCO. hkp://keyserver.gingerbear.net  or
     mailto:[email-masked]?subject=HELP

Q:"Just how do the residents of Haiku, Hawai'i hold conversations?"
A:"An odd melody / island voices on the winds / surplus of vowels"

---

From: Jon Callas <[email-masked]>
Date: Mon, 2 Feb 2009 10:50:09 -0800

>                             To what extent are their goals aligned?   
> More specifically, since (b) is a corporation
>                             which is driven by the profit motive and  
> (a) would like to make a reasonable living
>                             but is likely more open than the average  
> corporate culture, it's likely more in the
>                             interested of (b) to succeed in being  
> universal but not too universal, i.e., to some

Frankly, this is an insult. The suggestion that because we make a  
living at this we must therefore be corrupt ticks me off.

What do *you* do for a living, and when did you stop cheating *your*  
customers?

We do this because we think it's a way to make the world a better  
place, that we can also make a living at it as well. Hal was one of  
the major developers of PGP 2 and was one of the people who risked  
going to jail for it. I was still heavily involved in OpenPGP during  
the years when it wasn't my job, as well. We are doing this because we  
love it. We happen to be good enough at it to also make a living. The  
suggestion that because we are making a living we must therefore be  
shafting the community says a lot more about your personal morals than  
ours.

That doesn't mean we're perfect, it means our hearts are in the right  
place. If you think we're doing the community wrong, send me an email  
and let me know.

Now then, let me go on to some other things. We think that the GnuPG  
guys are friends and allies who make things that we *can't* make.  
Ditto for the new library that Ben and Rachel did. We applaud them.  
The world needs more OpenPGP, and the best way to get it is to have  
more Open Source.

There are differences between GnuPG and PGP, and that's somewhere  
between irrelevant and a good thing. As John Clizbe pointed out, the  
success of the standard is interoperability. It's actually a good  
thing to have two implementations that aren't completely in lock-step,  
but have a "friends can disagree" attitude about some things. We also  
as a community put that into the standard itself, that there are many  
things that gentlepersons can disagree on.

For example, in the days we first created the OpenPGP standard, there  
was a lot of debate about symmetric ciphers. Two major ones were CAST5  
and Blowfish. To avoid an endless, useless debate about it, they were  
both put in. In the post-AES that debate is almost entirely historic.  
But PGP didn't implement Blowfish because Phil Zimmermann hates it --  
he was a huge CAST5 proponent. His opinion carries on to this day  
because no one is screaming for us to put Blowfish in (it's mostly  
historic, as I said). When PGP Corporation was formed, we put in  
decryption of Blowfish because it aids interoperability and wouldn't  
require UI and documentation changes. Odds are, this is probably all  
news to you and that shows how well the standard works.

We consider interop bugs to be serious. Whenever we find some rough  
edge, you'll likely find me, Hal, David, and Werner huddling in the  
back room to figure out what to do. Sometimes that turns into a note  
on this list. Sometimes one or the other or both of us fix the  
problem. We're friends with common goals and different user bases.

	Jon

---

From: "gerry_lowry \(alliston ontario canada\)" <[email-masked]>
Date: Mon, 2 Feb 2009 20:59:34 -0500

Jon,

I regret that you took the nature of my question as an insult.  None, per se, was intended.

My first question imho is fair.  This forum consists of the meta experts likely best suited
to answer that question.

In no way am I talking about individuals when I ask about PGP Corporation.
I'm guessing that PGP Corporation may be a good place to be and that you
work for them.  I was semi-correct about you ... from http://www.merrymeet.com/jon/
I see that you used to work for PGP Corporation.  Of course, your page reads
"Last Updated: 8 April 2001" so perhaps you're back with PGP Corporation.
[BTW, http://www.merrymeet.com/jon/FGuru.JPG shows a very chilled you.]
___________________________________________________________

OTOH, that corporations can be psychopathic is well documented.

E.g.:  http://www.thecorporation.com/
         http://www.thecorporation.com/index.cfm?page_id=2
         Above is a film based on this book:
         "The Corporation: The Pathological Pursuit of Profit and Power",
         Free Press (February 2004), ISBN-10: 0743247442, ISBN-13: 978-0743247443  
         
         from http://www.penguin.ca/nf/Book/BookDisplay/0,,9780140290042,00.html :
         "Joel Bakan's new book is a brilliantly argued account of the
         corporation's pathological pursuit of profit and power. An eminent law professor
         and legal theorist, Bakan contends that the corporation is created by law to function
         much like a psychopathic personality whose destructive behavior, if left unchecked,
         leads to scandal and ruin." 

We've recently seen the horror corporations have brought about to the economy
of the entire planet.  Of course, a few humans were complicit too.

So, even if today some corporation is 100% altruistic, a change in its governance
can turn it into a demon overnight.  Example:  search "Google layoffs".  Google
was that company that brought in a chef for its staff in the early days.

I, myself, have had my corporate loyalty rewarded more than once with a
kick in the groin.

So "making a living" does not necessarily make an individual corrupt
although this is not always the case.  There are some alledged/convicted
"bad apples" that come to mind (Bernard Madoff, Ken Lay, Bernard Ebbers,
Jeffrey Skilling, et al).

Jon, *I* write code and consult, et cetera, although presently I can
not call it a living.  Unfortunately, most of my eggs were in one basket
whose market sector is trucking.  Consultants are usually the first to
be shown the door.  While a few of my customers may disagree,
I've never had to stop cheating *them* because I've never started.
Not even the few that actually deserve to be cheated.

I envy you that you "love it" and also "happen to be good enough at it
to also make a living".

Before you make judgements about my personal morals, I suggest
that you get to know me.

Jon, as I said I'm a newbie ... I'm not here to trash anyone.
Thank you for sharing answers to my questions also.

Happy levitating!

Regards,
Gerry (Lowry)

---

From: Werner Koch <[email-masked]>
Date: Tue, 03 Feb 2009 09:55:50 +0100

> guys are friends and allies who make things that we *can't* make.  

I concur.

Salam-Shalom,

   Werner

-- 
Die Gedanken sind frei.  Auschnahme regelt ein Bundeschgesetz.

---

From: Ian G <[email-masked]>
Date: Tue, 03 Feb 2009 14:00:03 +0100

>  To what extent are their goals aligned?

To the extent agreed in the OpenPGP RFC.  They both produce working code 
to that document, and it seems to happily exchange messages.  That is 
the point of the document.

>  OTOH, it's possible AFAIK that (a) could not succeed without being 100%

I think it is a reasonable question to ask about the structure of the 
OpenPGP microindustry, although rather hard to voice without appearing 
insensitive :)

The thing is, the market for OpenPGP (both paid and FLOSS) is very very 
small.  In such a market, the competitors can actually do far better by 
working together.  They can grow the market more easily that way.

If this were a "saturated market" and no growth were possible, then 
stealing a client from the competitor would represent the only growth 
possibility, so then we would expect to see some mutual canibalisation 
and hence what you might think of as bad behaviour.

To perhaps put a controversial spin on it, the question can be turned 
around.  To what extent can we trust the various players to stick to 
their stated goals?  Without talking about say GnuPG (which I know 
little about) I can suggest that it is pretty easy to pervert an open 
source organisation.  Here's two common ways:

     * cut a secret deal with them.

     * pay your developers to work on their project.

For both of those, a corporation has an easier time with the attack 
(which is balanced by other things of course).

If one were to do a scorecard on how aligned the stated goals were with 
the actual events and work done by the players, OpenPGP security 
community would score quite highly.  Other security projects would score 
far more badly, and are a cause for serious concern.

iang

PS: which reminds me, I did that a few years back, and PGP Inc did score 
pretty highly:
http://iang.org/ssl/security_metrics.html